using System;
using System.Configuration;
using System.Collections.Specialized;
using System.Data;
using System.Data.SqlClient;
using System.Web.Security;

namespace GolfClubShack.Security {
	public class GolfClubShackMembershipProvider: IMembershipProvider {
		private string _ApplicationName;
		private bool _EnablePasswordReset = true;
		private bool _EnablePasswordRetrieval = true;
		private bool _RequiresQuestionAndAnswer = true;
		private string _Name;
		private string _ConnStr;

		public GolfClubShackMembershipProvider() {
			_ConnStr = ConfigurationSettings.ConnectionStrings["ConnectionString"];
		}
		
		public string ApplicationName {
			get { return _ApplicationName; }
			set { _ApplicationName = value; }
		}
		public string Name {
			get {
				if (_Name != null) {
					return _Name;
				}
				else {
					return "GolfClubShackMembershipProvider";
				}
			}
		}
		public bool EnablePasswordReset {
			get { return _EnablePasswordReset; }
		}
		public bool EnablePasswordRetrieval {
			get { return _EnablePasswordRetrieval; }
		}
		public bool RequiresQuestionAndAnswer {
			get { return _RequiresQuestionAndAnswer; }
		}

		public virtual void Initialize(string name, NameValueCollection config) {
	        _EnablePasswordRetrieval = Boolean.Parse(config["enablePasswordRetrieval"]);
            _EnablePasswordReset = Boolean.Parse(config["enablePasswordReset"]);
            _RequiresQuestionAndAnswer = Boolean.Parse(config["requiresQuestionAndAnswer"]);
            _ApplicationName = config["applicationName"];
        }

		public bool ChangePassword(string name, string oldPwd, string newPwd) {
			return false;
		}

		public bool ChangePasswordQuestionAndAnswer(string name, string password, string newPwdQuestion, string newPwdAnswer) {
			return false;
		}

		public MembershipUser CreateUser(string username, string password, string email, out MembershipCreateStatus status) {
			return CreateUser(username, password, email, null, out status);
		}

		public MembershipUser CreateUser(string username, string password, string email, string fullname,out MembershipCreateStatus status) {
			SqlConnection conn = null;
			try {
				conn = new SqlConnection(_ConnStr);
				SqlCommand cmd = new SqlCommand("CustomerAdd", conn);
				cmd.CommandType = CommandType.StoredProcedure;
				conn.Open();
				SqlParameter paramEmail = cmd.Parameters.Add(
				    new SqlParameter("@Email",SqlDbType.NVarChar,50));
				paramEmail.Value = username;
				SqlParameter paramPassword = cmd.Parameters.Add(
				    new SqlParameter("@Password", SqlDbType.NVarChar, 50));
				paramEmail.Value = password;
				SqlParameter paramFullName = cmd.Parameters.Add(
				    new SqlParameter("@FullName", SqlDbType.NVarChar, 50));
				paramEmail.Value = fullname;

				cmd.ExecuteNonQuery();
				status = MembershipCreateStatus.Success;
				return new MembershipUser(this, 
					this.Name, email, null, null, true, DateTime.Now, 
					DateTime.Now, DateTime.Now, DateTime.Now);
			}
			catch {
				status = MembershipCreateStatus.ProviderError;
				return null;
			}
			finally {
				if (conn.State != ConnectionState.Closed) conn.Close();
			}
		}

		public bool DeleteUser(string name) {
			//Todo
			return false;
		}

		public MembershipUserCollection GetAllUsers() {
			//Todo
			return null;
		}

		public int GetNumberOfUsersOnline() {
			//Todo
			return 0;
		}

		public string GetPassword(string name, string answer) {
			SqlConnection conn = null;
			try {
				conn = new SqlConnection(_ConnStr);
				SqlCommand cmd = new SqlCommand("CustomerPassword", conn);
				cmd.CommandType = CommandType.StoredProcedure;
				conn.Open();

				SqlParameter paramEmail = cmd.Parameters.Add(new SqlParameter("@Email", SqlDbType.NVarChar, 50));
				paramEmail.Value = name;

				SqlParameter paramPassword = cmd.Parameters.Add(new SqlParameter("@Password", SqlDbType.NVarChar,50));
				paramPassword.Direction = ParameterDirection.Output;
				cmd.ExecuteNonQuery();

				return paramPassword.Value.ToString();

			}
			catch {
				return String.Empty;
			}
			finally {
				if (conn.State != ConnectionState.Closed) conn.Close();
			}
		}

		public MembershipUser GetUser(string name, bool userIsOnline) {
			return new MembershipUser(this,name,name, null, null, true, DateTime.Now, DateTime.Now, DateTime.Now, DateTime.Now);
		}

		public string GetUserNameByEmail(string email) {
			return email;
		}

		public string ResetPassword(string name, string answer) {
			//Todo
			return String.Empty;
		}

		public void UpdateUser(MembershipUser user) {
			//Todo
		}


		public bool ValidateUser(string name, string password) {
			SqlConnection conn = null;
			try {
				System.Web.HttpContext.Current.Response.Write("in");
				conn = new SqlConnection(_ConnStr);
				SqlCommand cmd = new SqlCommand("CustomerLogin", conn);

				cmd.CommandType = CommandType.StoredProcedure;
				conn.Open();

				SqlParameter paramEmail = cmd.Parameters.Add(new SqlParameter("@Email", SqlDbType.NVarChar, 50));
				paramEmail.Value = name;

				SqlParameter paramPassword = cmd.Parameters.Add(new SqlParameter("@Password", SqlDbType.NVarChar, 50));
				paramPassword.Value = password;

				SqlParameter paramCustID = cmd.Parameters.Add(new SqlParameter("@CustomerID", SqlDbType.Int));
				paramCustID.Direction = ParameterDirection.Output;
				
				cmd.ExecuteNonQuery();
				int custID = (int)paramCustID.Value;
				if (custID != 0) {
					return true;
				}
				else {
					return false;
				}
			}
			catch {
				return false;
			}
			finally {
				if (conn.State != ConnectionState.Closed) conn.Close();
			}
		}

	}
}

